#ifndef FUNCS_H 
#define FUNCS_H 
unsigned long  MakeAtom(char  *string,unsigned short  len,int  makeit, struct _Node *);
int  ValidAtom(unsigned long  atom);
char  *NameForAtom(unsigned long  atom);
void  AtomError(void);
void  InitAtoms(void);
void  FreeCursor(unsigned char  *ptr,unsigned long  cid);
struct  _DeviceRec *AddInputDevice(int  (*deviceProc)(),int  autoStart);
int  InitAndStartDevices(void);
void  CloseDownDevices(void);
int  NumMotionEvents(void);
void  RegisterPointerDevice(struct  _DeviceRec *device);
void  RegisterKeyboardDevice(struct  _DeviceRec *device);
struct  _DeviceRec *LookupKeyboardDevice(void);
struct  _DeviceRec *LookupPointerDevice(void);
void  QueryMinMaxKeyCodes(unsigned char  *minCode,unsigned char  *maxCode);
int  InitKeyClassDeviceStruct(struct  _DeviceIntRec *dev,struct  _KeySymsRec *pKeySyms,unsigned char  *pModifiers);
int  InitButtonClassDeviceStruct(struct  _DeviceIntRec *dev,int  numButtons,unsigned char  *map);
int  InitValuatorClassDeviceStruct(struct  _DeviceIntRec *dev,int  numAxes,int  (*motionProc)(),int  numMotionEvents,int  mode);
int  InitFocusClassDeviceStruct(struct  _DeviceIntRec *dev);
int  InitPtrFeedbackClassDeviceStruc(struct  _DeviceIntRec *dev,void  (*controlProc)());
int  InitPointerDeviceStruct(struct  _DeviceRec *device,unsigned char  *map,int  numButtons,int  (*motionProc)(),void  (*controlProc)(),int  numMotionEvents);
int  InitKeyboardDeviceStruct(struct  _DeviceRec *device,struct  _KeySymsRec *pKeySyms,unsigned char  *pModifiers,void  (*bellProc)(),void  (*controlProc)());
void SendMappingNotify(unsigned char  request,unsigned char  firstKeyCode,unsigned char  count);
int  BadDeviceMap(unsigned char  *buff,int  length,unsigned int low,unsigned int high,unsigned long  *errval);
int   _ProcSetModifierMapping(struct  _Client  *client);
int   _ProcGetModifierMapping(struct  _Client  *client);
int   _ProcChangeKeyboardMapping(struct  _Client  *client);
int   _ProcSetPointerMapping(struct  _Client  *client);
int   _ProcGetKeyboardMapping(struct  _Client  *client);
int   _ProcGetPointerMapping(struct  _Client  *client);
void  NoteLedState(struct  _DeviceIntRec *keybd,int  led,int  on);
int    ProcChangeKeyboardControl(struct  _Client  *client);
int   _ProcGetKeyboardControl(struct  _Client  *client);
int   _ProcBell(struct  _Client  *client);
int   _ProcChangePointerControl(struct  _Client  *client);
int   _ProcGetPointerControl(struct  _Client  *client);
void  MaybeStopHint(struct  _DeviceIntRec *dev,struct  _Client  *client);
int   _ProcGetMotionEvents(struct  _Client  *client);
int   _ProcQueryKeymap(struct  _Client  *client);
void  SetInputCheck(unsigned int *c0,unsigned int *c1);
void  UpdateCurrentTime(void);
void  UpdateCurrentTimeIf(void);
void  InitSelections(void);
void  FlushClientCaches(unsigned long  id);
void  Dispatch(void);
int    ProcBadRequest(struct  _Client  *client);
int    ProcCreateWindow(struct  _Client  *client);
int    ProcChangeWindowAttributes(struct  _Client  *client);
int    ProcGetWindowAttributes(struct  _Client  *client);
int    ProcDestroyWindow(struct  _Client  *client);
int    ProcDestroySubwindows(struct  _Client  *client);
int    ProcChangeSaveSet(struct  _Client  *client);
int    ProcReparentWindow(struct  _Client  *client);
int    ProcMapWindow(struct  _Client  *client);
int    ProcMapSubwindows(struct  _Client  *client);
int    ProcUnmapWindow(struct  _Client  *client);
int    ProcUnmapSubwindows(struct  _Client  *client);
int    ProcConfigureWindow(struct  _Client  *client);
int    ProcCirculateWindow(struct  _Client  *client);
int    ProcGetGeometry(struct  _Client  *client);
int    ProcQueryTree(struct  _Client  *client);
int    ProcInternAtom(struct  _Client  *client);
int    ProcGetAtomName(struct  _Client  *client);
int    ProcDeleteProperty(struct  _Client  *client);
int    ProcSetSelectionOwner(struct  _Client  *client);
int    ProcGetSelectionOwner(struct  _Client  *client);
int    ProcConvertSelection(struct  _Client  *client);
int    ProcGrabServer(struct  _Client  *client);
int    ProcUngrabServer(struct  _Client  *client);
int    ProcTranslateCoords(struct  _Client  *client);
int    ProcOpenFont(struct  _Client  *client);
int    ProcCloseFont(struct  _Client  *client);
int    ProcQueryFont(struct  _Client  *client);
int    ProcQueryTextExtents(struct  _Client  *client);
int    ProcListFonts(struct  _Client  *client);
int    ProcListFontsWithInfo(struct  _Client  *client);
void dixDestroyPixmap(void *pPixmap,unsigned long  pid);
int    ProcCreatePixmap(struct  _Client  *client);
int    ProcFreePixmap(struct  _Client  *client);
int    ProcCreateGC(struct  _Client  *client);
int    ProcChangeGC(struct  _Client  *client);
int    ProcCopyGC(struct  _Client  *client);
int    ProcSetDashes(struct  _Client  *client);
int    ProcSetClipRectangles(struct  _Client  *client);
int    ProcFreeGC(struct  _Client  *client);
int    ProcClearToBackground(struct  _Client  *client);
int    ProcCopyArea(struct  _Client  *client);
int    ProcCopyPlane(struct  _Client  *client);
int    ProcPolyPoint(struct  _Client  *client);
int    ProcPolyLine(struct  _Client  *client);
int    ProcPolySegment(struct  _Client  *client);
int    ProcPolyRectangle(struct  _Client  *client);
int    ProcPolyArc(struct  _Client  *client);
int    ProcFillPoly(struct  _Client  *client);
int    ProcPolyFillRectangle(struct  _Client  *client);
int    ProcPolyFillArc(struct  _Client  *client);
int    ProcPutImage(struct  _Client  *client);
int    ProcGetImage(struct  _Client  *client);
int    ProcPolyText(struct  _Client  *client);
int    ProcImageText8(struct  _Client  *client);
int    ProcImageText16(struct  _Client  *client);
int    ProcCreateColormap(struct  _Client  *client);
int    ProcFreeColormap(struct  _Client  *client);
int    ProcCopyColormapAndFree(struct  _Client  *client);
int    ProcInstallColormap(struct  _Client  *client);
int    ProcUninstallColormap(struct  _Client  *client);
int    ProcListInstalledColormaps(struct  _Client  *client);
int    ProcAllocColor(struct  _Client  *client);
int    ProcAllocNamedColor(struct  _Client  *client);
int    ProcAllocColorCells(struct  _Client  *client);
int    ProcAllocColorPlanes(struct  _Client  *client);
int    ProcFreeColors(struct  _Client  *client);
int    ProcStoreColors(struct  _Client  *client);
int    ProcStoreNamedColor(struct  _Client  *client);
int    ProcQueryColors(struct  _Client  *client);
int    ProcLookupColor(struct  _Client  *client);
int    ProcCreateCursor(struct  _Client  *client);
int    ProcCreateGlyphCursor(struct  _Client  *client);
int    ProcFreeCursor(struct  _Client  *client);
int    ProcQueryBestSize(struct  _Client  *client);
int    ProcSetScreenSaver(struct  _Client  *client);
int    ProcGetScreenSaver(struct  _Client  *client);
int    ProcChangeHosts(struct  _Client  *client);
int    ProcListHosts(struct  _Client  *client);
int    ProcChangeAccessControl(struct  _Client  *client);
int    ProcKillClient(struct  _Client  *client);
int    ProcSetFontPath(struct  _Client  *client);
int    ProcGetFontPath(struct  _Client  *client);
int    ProcChangeCloseDownMode(struct  _Client  *client);
int    ProcForceScreenSaver(struct  _Client  *client);
int    ProcNoOperation(struct  _Client  *client);
void   InitProcVectors(void);
void  CloseDownClient(struct  _Client  *client);
struct  _Client  *NextAvailableClient(void *ospriv);
int    ProcInitialConnection(struct  _Client  *client);
int    ProcEstablishConnection(struct  _Client  *client);
int    ProcRotateProperties(struct  _Client  *client);
int    ProcChangeProperty(struct  _Client  *client);
int    ProcGetProperty(struct  _Client  *client);
int    ProcListProperties(struct  _Client  *client);
int    ProcQueryExtension(struct  _Client  *client);
int    ProcListExtensions(struct  _Client  *client);
int    ProcSetModifierMapping(struct  _Client  *client);
int    ProcGetModifierMapping(struct  _Client  *client);
int    ProcChangeKeyboardMapping(struct  _Client  *client);
int    ProcSetPointerMapping(struct  _Client  *client);
int    ProcGetKeyboardMapping(struct  _Client  *client);
int    ProcGetPointerMapping(struct  _Client  *client);
int    ProcGetKeyboardControl(struct  _Client  *client);
int    ProcBell(struct  _Client  *client);
int    ProcChangePointerControl(struct  _Client  *client);
int    ProcGetPointerControl(struct  _Client  *client);
int    ProcGetMotionEvents(struct  _Client  *client);
int    ProcQueryKeymap(struct  _Client  *client);
void  DeleteWindowFromAnySelections(struct  _Window  *pWin);
void  MarkClientException(struct  _Client  *client);
int  SetDefaultFont(char  *defaultfontname);
void  CloseFont(unsigned char  *ptr,unsigned long  fid);
int  DescribeFont(char  *pfontname,int  lenfname,struct  _FontInfo *pfi,struct  _DIXFontProp * *ppfp);
void  QueryFont(struct  _Font *pf,struct  _xQueryFontReply *pr,int  nprotoxcistructs);
void  queryCharInfo(struct  _CharInfo *pci,struct  _xCharInfo *pr);
void  GetGlyphs(struct  _Font *font,unsigned int  count,unsigned char  *chars,int  fontEncoding,unsigned int  *glyphcount,struct  _CharInfo * *glyphs);
void  QueryGlyphExtents(struct  _Font *font,struct  _CharInfo * *charinfo,unsigned long  count,struct  _ExtentInfo *info);
int  QueryTextExtents(struct  _Font *font,unsigned int  count,unsigned char  *chars,struct  _ExtentInfo *info);
void  CopyISOLatin1Lowered(unsigned char  *dest,unsigned char  *source,int  length);
struct  _Window  *LookupWindow(unsigned long  rid,struct  _Client  *client);
struct  _Drawable  * LookupDrawable(unsigned long  rid,struct  _Client  *client);
int  AlterSaveSetForClient(struct  _Client  *client,struct  _Window  *pWin,unsigned int mode);
void DeleteWindowFromAnySaveSet(struct  _Window  *pWin);
void  NoopDDA(void);
unsigned long  GetNextEventMask(void);
void  SetMaskForEvent(unsigned long  mask,int  event);
void  SetCriticalEvent(int  event);
int  PointerConfinedToScreen(void);
int  IsParent(struct  _Window  *a,struct  _Window  *b);
struct  _Window  *GetCurrentRootWindow(void);
struct  _Window  *GetSpriteWindow(void);
void RedrawScreen(void);
void  NoticeEventTime(struct  _XEvent *xE);
void  ComputeFreezes(void);
void  CheckGrabForSyncs(struct  _DeviceIntRec *thisDev,int  thisMode,int  otherMode);
void  DeactivatePointerGrab(struct  _DeviceIntRec *mouse);
void  DeactivateKeyboardGrab(struct  _DeviceIntRec *keybd);
int    ProcAllowEvents(struct  _Client  *client);
void  ReleaseActiveGrabs(struct  _Client  *client);
int  TryClientEvents(struct  _Client  *client,struct  _XEvent *pEvents,int  count,unsigned long  mask,unsigned long  filter,struct  _GrabRec *grab);
int  MaybeDeliverEventsToClient(struct  _Window  *pWin,struct  _XEvent *pEvents,int  count,unsigned long  filter,struct  _Client  *dontClient);
int  DeliverDeviceEvents(struct  _Window  *pWin, struct  _XEvent *xE,
	struct  _GrabRec *grab, struct  _Window  *stopAt,
	struct  _DeviceIntRec *dev, int  count);
int  DeliverEvents(struct  _Window  *pWin,struct  _XEvent *xE,int  count,struct  _Window  *otherParent);
int  WindowsRestructured(void);
void    DefineInitialRootWindow(struct  _Window  *win);
void  WindowHasNewCursor(struct  _Window  *pWin);
void  NewCurrentScreen(struct  _Screen  *newScreen,int  x,int  y);
int    ProcWarpPointer(struct  _Client  *client);
int  CheckDeviceGrabs(struct  _DeviceIntRec *device,struct  _XEvent *xE,int  checkFirst,int  count);
void  DeliverFocusedEvent(struct  _DeviceIntRec *keybd,struct  _XEvent *xE,struct  _Window  *window,int  count);
void  DeliverGrabbedEvent(struct  _XEvent *xE,struct  _DeviceIntRec *thisDev,int  deactivateGrab,int  count);
void  ProcessKeyboardEvent(struct  _XEvent *xE,struct  _DeviceIntRec *keybd,int  count);
void  ProcessPointerEvent(struct  _XEvent *xE,struct  _DeviceIntRec *mouse,int  count);
void RecalculateDeliverableEvents(struct  _Window  *pWin);
void OtherClientGone(unsigned char  *ptr,unsigned long  id);
int  EventSelectForWindow(struct  _Window  *pWin,struct  _Client  *client,unsigned long  mask);
int  EventSuppressForWindow(struct  _Window  *pWin,struct  _Client  *client,unsigned long  mask,int  *checkOptional);
void  DoFocusEvents(struct  _DeviceIntRec *dev,struct  _Window  *fromWin,struct  _Window  *toWin,int  mode);
int  SetInputFocus(struct  _Client  *client,struct  _DeviceIntRec *dev,unsigned long  focusID,unsigned char  revertTo,unsigned long  ctime,int  followOK);
int    ProcSetInputFocus(struct  _Client  *client);
int    ProcGetInputFocus(struct  _Client  *client);
int    ProcGrabPointer(struct  _Client  *client);
int    ProcChangeActivePointerGrab(struct  _Client  *client);
int    ProcUngrabPointer(struct  _Client  *client);
int  GrabDevice(struct  _Client  *client,struct  _DeviceIntRec *dev,unsigned int  this_mode,unsigned int  other_mode,unsigned long  grabWindow,unsigned int ownerEvents,unsigned long  ctime,unsigned long  mask,unsigned char  *status);
int    ProcGrabKeyboard(struct  _Client  *client);
int    ProcUngrabKeyboard(struct  _Client  *client);
int    ProcQueryPointer(struct  _Client  *client);
void   InitEvents(void);
int    ProcSendEvent(struct  _Client  *client);
int    ProcUngrabKey(struct  _Client  *client);
int    ProcGrabKey(struct  _Client  *client);
int    ProcGrabButton(struct  _Client  *client);
int    ProcUngrabButton(struct  _Client  *client);
void  DeleteWindowFromAnyEvents(struct  _Window  *pWin,int  freeResources);
void  CheckCursorConfinement(struct  _Window  *pWin);
unsigned long  EventMaskForClient(struct  _Window  *pWin,struct  _Client  *client);
int    ProcRecolorCursor(struct  _Client  *client);
void  WriteEventsToClient(struct  _Client  *pClient,int  count,struct  _XEvent *events);
struct  _ExtensionEntry *AddExtension(char  *name,int  NumEvents,int  NumErrors,int  (  *MainProc)(struct  _Client  *),int  (  *SwappedMainProc)(struct  _Client  *),void  (*CloseDownProc)(),unsigned short  (*MinorOpcodeProc)());
int  AddExtensionAlias(char  *alias,struct  _ExtensionEntry *ext);
unsigned short  StandardMinorOpcode(struct  _Client  *client);
unsigned short  MinorOpcodeOfRequest(struct  _Client  *client);
void  CloseDownExtensions(void);
int  _ProcQueryExtension(struct  _Client  *client);
int  _ProcListExtensions(struct  _Client  *client);
void  (*LookupProc(char  *name,struct  _GC *pGC))();
int  RegisterProc(char  *name,struct  _GC *pGC,void  (*proc)());
int  RegisterScreenProc(char  *name,struct  _Screen  *pScreen,void  (*proc)());
void  ValidateGC(struct  _Drawable  *pDraw,struct  _GC *pGC);
int  ChangeGC(struct  _GC *pGC,unsigned long  mask,unsigned long  *pval);
int  DoChangeGC(struct  _GC *pGC,unsigned long  mask,unsigned long  *pval,int  fPointer);
void   ResetGCPrivates(void);
int  AllocateGCPrivateIndex(void);
struct  _GC *CreateGC(struct  _Drawable  *pDrawable,unsigned long  mask,unsigned long  *pval,int  *pStatus);
int  CopyGC(struct  _GC *pgcSrc,struct  _GC *pgcDst,unsigned long  mask);
void  FreeGC(unsigned char  *gc,unsigned long  gid);
void  SetGCMask(struct  _GC *pGC,unsigned long  selectMask,unsigned long  newDataMask);
struct  _GC *CreateScratchGC(struct  _Screen  *pScreen,unsigned int  depth);
void FreeGCperDepth(int  screenNum);
int  CreateGCperDepth(int  screenNum);
int  CreateDefaultStipple(int  screenNum);
void FreeDefaultStipple(int  screenNum);
int  SetDashes(struct  _GC *pGC,unsigned int offset,unsigned int ndash,unsigned char  *pdash);
int  VerifyRectOrder(int  nrects,struct  _xRectangle *prects,int  ordering);
int  SetClipRects(struct  _GC *pGC,int  xOrigin,int  yOrigin,int  nrects,struct  _xRectangle *prects,int  ordering);
void  FreeScratchGC(struct  _GC *pGC);
int  ServerBitsFromGlyph(struct  _Font *pfont,unsigned short  ch,struct  _CursorMetric *cm,unsigned char  * *ppbits);
struct  _GrabRec *CreateGrab(int  client,struct  _DeviceIntRec *device,struct  _Window  *window,unsigned long  eventMask,int  ownerEvents,int  keyboardMode,int  pointerMode,struct  _DeviceIntRec *modDevice,unsigned short  modifiers,int  type,unsigned char  keybut,struct  _Window  *confineTo,struct  _Cursor *cursor);
void  DeletePassiveGrab(unsigned char  *ptr,unsigned long  id);
int  GrabMatchesSecond(struct  _GrabRec *pFirstGrab,struct  _GrabRec *pSecondGrab);
int  AddPassiveGrabToList(struct  _GrabRec *pGrab);
int  DeletePassiveGrabFromList(struct  _GrabRec *pMinuendGrab);
void   MakePredeclaredAtoms(void);
void  NotImplemented(void);
int  main(int  argc,char  * *argv);
int  AllocateScreenPrivateIndex(void);
int  AddScreen(int  (*pfnInit)(int  ,struct  _Screen  *,int  ,char  * *),int  argc,char  * *argv);
int   _ProcRotateProperties(struct  _Client  *client);
int   _ProcChangeProperty(struct  _Client  *client);
int  DeleteProperty(struct  _Window  *pWin,unsigned long  propName);
void DeleteAllWindowProperties(struct  _Window  *pWin);
int   _ProcGetProperty(struct  _Client  *client);
int   _ProcListProperties(struct  _Client  *client);
unsigned short  CreateNewResourceType(int  (*deleteFunc)(unsigned char  *,unsigned long  ));
unsigned short  CreateNewResourceClass(void);
int   InitClientResources(struct  _Client  *client);
unsigned long   FakeClientID(int  client);
int  AddResource(unsigned long  id,unsigned short  type,unsigned char  *value);
void  FreeResource(unsigned long  id,unsigned short  skipDeleteFuncType);
void  FreeResourceByType(unsigned long  id,unsigned short  type,int  skipFree);
int  ChangeResourceValue(unsigned long  id,unsigned short  rtype,unsigned char  *value);
void   FreeClientResources(struct  _Client  *client);
void FreeAllResources(void);
int  LegalNewID(unsigned long  id,struct  _Client  *client);
void *LookupIDByType(unsigned long  id,unsigned short  rtype);
void *LookupIDByClass(unsigned long  id,unsigned short  classes);
void  ShapeExtensionInit(void);
int  Swap32Write(struct  _Client  *pClient,int  size,long  *pbuf);
int  CopySwap32Write(struct  _Client  *pClient,int  size,long  *pbuf);
int  CopySwap16Write(struct  _Client  *pClient,int  size,short  *pbuf);
void  SGenericReply(struct  _Client  *pClient,int  size,struct  _xGenericReply *pRep);
void  SGetWindowAttributesReply(struct  _Client  *pClient,int  size,struct  _xGetWindowAttributesReply *pRep);
void  SGetGeometryReply(struct  _Client  *pClient,int  size,struct  _xGetGeometryReply *pRep);
void  SQueryTreeReply(struct  _Client  *pClient,int  size,struct  _xQueryTreeReply *pRep);
void  SInternAtomReply(struct  _Client  *pClient,int  size,struct  _xInternAtomReply *pRep);
void  SGetAtomNameReply(struct  _Client  *pClient,int  size,struct  _xGetAtomNameReply *pRep);
void  SGetPropertyReply(struct  _Client  *pClient,int  size,struct  _xGetPropertyReply *pRep);
void  SListPropertiesReply(struct  _Client  *pClient,int  size,struct  _xListPropertiesReply *pRep);
void  SGetSelectionOwnerReply(struct  _Client  *pClient,int  size,struct  _xGetSelectionOwnerReply *pRep);
void  SQueryPointerReply(struct  _Client  *pClient,int  size,struct  _xQueryPointerReply *pRep);
void  SwapTimeCoordWrite(struct  _Client  *pClient,int  size,struct  _xTimecoord *pRep);
void  SGetMotionEventsReply(struct  _Client  *pClient,int  size,struct  _xGetMotionEventsReply *pRep);
void  STranslateCoordsReply(struct  _Client  *pClient,int  size,struct  _xTranslateCoordsReply *pRep);
void  SGetInputFocusReply(struct  _Client  *pClient,int  size,struct  _xGetInputFocusReply *pRep);
void  SQueryKeymapReply(struct  _Client  *pClient,int  size,struct  _xQueryKeymapReply *pRep);
void  SQueryFontReply(struct  _Client  *pClient,int  size,struct  _xQueryFontReply *pRep);
void  SQueryTextExtentsReply(struct  _Client  *pClient,int  size,struct  _xQueryTextExtentsReply *pRep);
void  SListFontsReply(struct  _Client  *pClient,int  size,struct  _xListFontsReply *pRep);
void  SListFontsWithInfoReply(struct  _Client  *pClient,int  size,struct  _xListFontsWithInfoReply *pRep);
void  SGetFontPathReply(struct  _Client  *pClient,int  size,struct  _xGetFontPathReply *pRep);
void  SGetImageReply(struct  _Client  *pClient,int  size,struct  _xGetImageReply *pRep);
void  SListInstalledColormapsReply(struct  _Client  *pClient,int  size,struct  _xListInstalledColormapsReply *pRep);
void  SAllocColorReply(struct  _Client  *pClient,int  size,struct  _xAllocColorReply *pRep);
void  SAllocNamedColorReply(struct  _Client  *pClient,int  size,struct  _xAllocNamedColorReply *pRep);
void  SAllocColorCellsReply(struct  _Client  *pClient,int  size,struct  _xAllocColorCellsReply *pRep);
void  SAllocColorPlanesReply(struct  _Client  *pClient,int  size,struct  _xAllocColorPlanesReply *pRep);
void  SQColorsExtend(struct  _Client  *pClient,int  size,struct  _xrgb *prgb);
void  SQueryColorsReply(struct  _Client  *pClient,int  size,struct  _xQueryColorsReply *pRep);
void  SLookupColorReply(struct  _Client  *pClient,int  size,struct  _xLookupColorReply *pRep);
void  SQueryBestSizeReply(struct  _Client  *pClient,int  size,struct  _xQueryBestSizeReply *pRep);
void  SListExtensionsReply(struct  _Client  *pClient,int  size,struct  _xListExtensionsReply *pRep);
void  SGetKeyboardMappingReply(struct  _Client  *pClient,int  size,struct  _xGetKeyboardMappingReply *pRep);
void  SGetPointerMappingReply(struct  _Client  *pClient,int  size,struct  _xGetPointerMappingReply *pRep);
void  SGetModifierMappingReply(struct  _Client  *pClient,int  size,struct  _xGetModifierMappingReply *pRep);
void  SGetKeyboardControlReply(struct  _Client  *pClient,int  size,struct  _xGetKeyboardControlReply *pRep);
void  SGetPointerControlReply(struct  _Client  *pClient,int  size,struct  _xGetPointerControlReply *pRep);
void  SGetScreenSaverReply(struct  _Client  *pClient,int  size,struct  _xGetScreenSaverReply *pRep);
void  SLHostsExtend(struct  _Client  *pClient,int  size,char  *buf);
void  SListHostsReply(struct  _Client  *pClient,int  size,struct  _xListHostsReply *pRep);
void  SErrorEvent(struct  _xError *from,struct  _xError *to);
void  SKeyButtonPtrEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SEnterLeaveEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SFocusEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SExposeEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SGraphicsExposureEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SNoExposureEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SVisibilityEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SCreateNotifyEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SDestroyNotifyEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SUnmapNotifyEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SMapNotifyEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SMapRequestEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SReparentEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SConfigureNotifyEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SConfigureRequestEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SGravityEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SResizeRequestEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SCirculateEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SPropertyEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SSelectionClearEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SSelectionRequestEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SSelectionNotifyEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SColormapEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SMappingEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SClientMessageEvent(struct  _XEvent *from,struct  _XEvent *to);
void  SKeymapNotifyEvent(struct  _XEvent *from,struct  _XEvent *to);
void  WriteSConnectionInfo(struct  _Client  *pClient,unsigned long  size,char  *pInfo);
void  SwapConnSetup(struct  _xConnSetup *pConnSetup,struct  _xConnSetup *pConnSetupT);
void  SwapWinRoot(struct  _xWindowRoot *pRoot,struct  _xWindowRoot *pRootT);
void  SwapVisual(struct  _xVisualType *pVis,struct  _xVisualType *pVisT);
void  WriteSConnSetupPrefix(struct  _Client  *pClient,struct  _xConnSetupPrefix *pcsp);
int    SProcSimpleReq(struct  _Client  *client);
int    SProcResourceReq(struct  _Client  *client);
int    SProcCreateWindow(struct  _Client  *client);
int    SProcChangeWindowAttributes(struct  _Client  *client);
int    SProcReparentWindow(struct  _Client  *client);
int    SProcConfigureWindow(struct  _Client  *client);
int    SProcInternAtom(struct  _Client  *client);
int    SProcChangeProperty(struct  _Client  *client);
int    SProcDeleteProperty(struct  _Client  *client);
int    SProcGetProperty(struct  _Client  *client);
int    SProcSetSelectionOwner(struct  _Client  *client);
int    SProcConvertSelection(struct  _Client  *client);
int    SProcSendEvent(struct  _Client  *client);
int    SProcGrabPointer(struct  _Client  *client);
int    SProcGrabButton(struct  _Client  *client);
int    SProcUngrabButton(struct  _Client  *client);
int    SProcChangeActivePointerGrab(struct  _Client  *client);
int    SProcGrabKeyboard(struct  _Client  *client);
int    SProcGrabKey(struct  _Client  *client);
int    SProcUngrabKey(struct  _Client  *client);
int    SProcGetMotionEvents(struct  _Client  *client);
int    SProcTranslateCoords(struct  _Client  *client);
int    SProcWarpPointer(struct  _Client  *client);
int    SProcSetInputFocus(struct  _Client  *client);
int    SProcOpenFont(struct  _Client  *client);
int    SProcListFonts(struct  _Client  *client);
int    SProcListFontsWithInfo(struct  _Client  *client);
int    SProcSetFontPath(struct  _Client  *client);
int    SProcCreatePixmap(struct  _Client  *client);
int    SProcCreateGC(struct  _Client  *client);
int    SProcChangeGC(struct  _Client  *client);
int    SProcCopyGC(struct  _Client  *client);
int    SProcSetDashes(struct  _Client  *client);
int    SProcSetClipRectangles(struct  _Client  *client);
int    SProcClearToBackground(struct  _Client  *client);
int    SProcCopyArea(struct  _Client  *client);
int    SProcCopyPlane(struct  _Client  *client);
int    SProcPoly(struct  _Client  *client);
int    SProcFillPoly(struct  _Client  *client);
int    SProcPutImage(struct  _Client  *client);
int    SProcGetImage(struct  _Client  *client);
int    SProcPolyText(struct  _Client  *client);
int    SProcImageText(struct  _Client  *client);
int    SProcCreateColormap(struct  _Client  *client);
int    SProcCopyColormapAndFree(struct  _Client  *client);
int    SProcAllocColor(struct  _Client  *client);
int    SProcAllocNamedColor(struct  _Client  *client);
int    SProcAllocColorCells(struct  _Client  *client);
int    SProcAllocColorPlanes(struct  _Client  *client);
int    SProcFreeColors(struct  _Client  *client);
int    SProcStoreColors(struct  _Client  *client);
int    SProcStoreNamedColor(struct  _Client  *client);
int    SProcQueryColors(struct  _Client  *client);
int    SProcLookupColor(struct  _Client  *client);
int    SProcCreateCursor(struct  _Client  *client);
int    SProcCreateGlyphCursor(struct  _Client  *client);
int    SProcRecolorCursor(struct  _Client  *client);
int    SProcQueryBestSize(struct  _Client  *client);
int    SProcQueryExtension(struct  _Client  *client);
int    SProcChangeKeyboardMapping(struct  _Client  *client);
int    SProcChangeKeyboardControl(struct  _Client  *client);
int    SProcChangePointerControl(struct  _Client  *client);
int    SProcSetScreenSaver(struct  _Client  *client);
int    SProcChangeHosts(struct  _Client  *client);
int    SProcRotateProperties(struct  _Client  *client);
int    SProcNoOperation(struct  _Client  *client);
void SwapTimecoord(struct  _xTimecoord *pCoord);
void SwapRGB(struct  _xrgb *prgb);
void SwapColorItem(struct  _xColorItem *pItem);
void SwapConnClientPrefix(struct  _xConnClientPrefix *pCCP);
int  CheckSubSaveUnder(struct  _Window  *pParent,struct  _Window  *pFirst,struct  _Region *pRegion);
int  CheckSaveUnder(struct  _Window  *pWin);
int  ChangeSaveUnder(struct  _Window  *pWin,struct  _Window  *first);
void  DoChangeSaveUnder(struct  _Window  *pWin,struct  _Window  *pFirst);
void   ResetWindowPrivates(void);
int  AllocateWindowPrivateIndex(void);
int  WalkTree(struct  _Screen  *pScreen,int  (*func)(struct  _Window  *,void  *),unsigned char  *data);
int  CreateRootWindow(struct  _Screen  *pScreen);
void  InitRootWindow(struct  _Window  *pWin);
void ClippedRegionFromBox(struct  _Window  *pWin,struct  _Region *Rgn,int  x,int  y,int  w,int  h);
struct  _Window  *RealChildHead(struct  _Window  *pWin);
struct  _Window  *CreateWindow(unsigned long  wid,struct  _Window  *pParent,short  x,short  y,unsigned short  w,unsigned short  h,unsigned short  bw,unsigned short  class,unsigned long  vmask,unsigned long  *vlist,int  depth,struct  _Client  *client,unsigned long  visual,int  *error);
void  DeleteWindow(unsigned char  *p,unsigned long  wid);
void  DestroySubwindows(struct  _Window  *pWin,struct  _Client  *client);
int  ChangeWindowAttributes(struct  _Window  *pWin,unsigned long  vmask,unsigned long  *vlist,struct  _Client  *client);
void  GetWindowAttributes(struct  _Window  *pWin,struct  _Client  *client);
struct  _Region *CreateUnclippedWinSize(struct  _Window  *pWin);
void  GravityTranslate(int  x,int  y,int  oldx,int  oldy,int  dw,int  dh,unsigned int gravity,int  *destx,int  *desty);
int  ConfigureWindow(struct  _Window  *pWin,unsigned long  mask,unsigned long  *vlist,struct  _Client  *client);
int  CirculateWindow(struct  _Window  *pParent,int  direction,struct  _Client  *client);
int  ReparentWindow(struct  _Window  *pWin,struct  _Window  *pParent,short  x,short  y,struct  _Client  *client);
int   MapWindow(struct  _Window  *pWin,struct  _Client  *client);
void  MapSubwindows(struct  _Window  *pParent,struct  _Client  *client);
void   UnmapWindow(struct  _Window  *pWin,int  fromConfigure);
void  UnmapSubwindows(struct  _Window  *pWin);
void  HandleSaveSet(struct  _Client  *client);
int  VisibleBoundingBoxFromPoint(struct  _Window  *pWin,int  x,int  y,struct  _Box *box);
int  PointInWindowIsVisible(struct  _Window  *pWin,int  x,int  y);
struct  _Region * NotClippedByChildren(struct  _Window  *pWin);
void  SendVisibilityNotify(struct  _Window  *pWin);
void  SaveScreens(int  on,int  mode);
struct  _Window  *FindWindowWithOptional(struct  _Window  *w);
void  CheckWindowOptionalNeed(struct  _Window  *w);
int  MakeWindowOptional(struct  _Window  *pWin);
void  DisposeWindowOptional(struct  _Window  *pWin);
void SetShape(struct _Window  *pWin);
void  FreeColormap(unsigned char  *ptr,unsigned long  mid);
void  FreeClientPixels(unsigned char  *p,unsigned long  fakeid);

void mxFixPage(void);
#endif 
